#include "asl.h"

int load_table(char path[], char **op[])
{
	/* 	read from text file opcode table or registers list
		and load them into op array or reg array
		return the actual number of operators or registers
	*/ 
	char input[1024];
  	//char *arg[2];
  	int i,r;
  	int k = 0;
  	FILE *fp;
  	fp = fopen(path, "r");
	if (fp < 0) 
	{
		printf("load_table() :%s: File not found!\n", path);
		return -1;
	}
	else printf("load_table() :%s loaded!\n", path);
  	while (fgets(input, 128, fp) > 0) {
		op[k] = (char **)malloc(sizeof(char*) * 10);
	  	r = parse(input, op[k]);		
		if (r == 0) continue;
		/*printf("Number of tokens: %d\n", r);
	  	for (i = 0; i < r; i++)
	  	{
	    	printf("op(%d)[%d] = %s\n", k, i, op[k][i]);
	  	}*/
	  	k++;
	}
	fclose(fp);
	return k;
}

int saveLabels(char *labelName, int lineNum, char **label[]) {
	char *buf = (char*)malloc(sizeof(char) * bitNum);
	buf = my_itoa(lineNum, buf, bitNum - 6, 2);
	//printf("buf = %s\n", buf);
	label[labelNum] = (char**)malloc(sizeof(char*) * 2);
	label[labelNum][0] = (char*)malloc(sizeof(char) * 128);
	label[labelNum][1] = (char*)malloc(sizeof(char) * bitNum);
	strcpy(label[labelNum][0], labelName);//label L1:
	strcpy(label[labelNum][1], buf);//position (line number) of L1:
	printf("label name = %s\n", label[labelNum][0]);
	printf("label code = %s\n", label[labelNum][1]);
	labelNum++;
	return 0;	
}

int getLabels(int lineNum, char *cmdLine[], char **op[], char **label[]) {
	int i;
	for (i = 0; i < opNum; i++) {//opNum: the real operators number
		//printf("OPCODE i = %d\n", i);
		if (strcmp(cmdLine[0], op[i][1]) == 0) {
			return 0;
		}		
	}	
	if (i != -1) {
		if (cmdLine[0][strlen(cmdLine[0]) - 1] == ':') {
			cmdLine[0][strlen(cmdLine[0]) - 1] = '\0';
			printf("line %d: %s: LABEL found!\n", lineNum, cmdLine[0]);			
			saveLabels(cmdLine[0], lineNum, label);
			printf("labelNum = %d\n", labelNum);
		}
		else {
			printf("line %d: %s: operator not found!\n", lineNum, cmdLine[0]);
			return -1;
		}
	}
	return 0;
}

int assemble(int lineNum, char *cmdLine[], int cmdLength, char **op[], char **reg[], char **label[], FILE *fd)
{
	/*  change directly assembly keywords(ADD, SUB...) 
		and registers' name (r1, r2...) in assembly 
		command line cmdLine into binary code
		due to opcode array op[] and registers array reg[]
		the result will be printed out by file fd
		
		return 0 if success, -1 if fail
	*/
	int i, k, operand_num, operator_type, tmpLen;
	int x;
	char *buf;
	char *tmp_buf = (char*)malloc(sizeof(char) * bitNum);
	
	buf = (char*)malloc((bitNum+1)*sizeof(char));
	printf("-------line %d\n", lineNum);
	
	/*search sequently if this operator belongs to the operators set or not*/
	for (i = 0; i < opNum; i++) {//opNum: the real operators number
		//printf("OPCODE i = %d\n", i);
		if (strcmp(cmdLine[0], op[i][1]) == 0) {
			strcpy(buf, op[i][0]);
			operand_num = atoi(op[i][2]);//get the number of operands for this operator
			operator_type = atoi(op[i][3]);
			printf("operator type = %d\n", operator_type);
			i = -1;//operator found!		
			break;
		}		
	}	
	if (i != -1) {
		if (cmdLine[0][strlen(cmdLine[0]) - 1] == ':') {
			printf("line %d: %s: LABEL found!\n", lineNum, cmdLine[0]);
			free(buf);
			return 0;
		}
	}
	
	//printf("command length = %d, op num = %d\n", cmdLength, operand_num);
	if (cmdLength != operand_num + 1) {
		printf("line %d: invalid operand length\n", lineNum);
		return -1; 
	}
	
	switch (operator_type) {
	case 1: //R-type instructions : ADD, SUB
		for (k = 1; k <= operand_num; k++) //n operands
		{
			for (i = 0; i < regNum; i++)//regNum: the real registers number 		
			{
				//printf("REG i = %d\n", i);
				if (strcmp(cmdLine[k], reg[i][1]) == 0)	{
					strcat(buf, reg[i][0]);
					i = -1;				
					break;
				}						
			}
			if (i != -1) {
				printf("line %d: %s: register not found!\n", lineNum, cmdLine[k]);
				return -1;
			}
		}
		break;
		
	case 2: //I-type instructions : LOAD, STORE
		for (k = 1; k <= operand_num; k++) //n operands
		{
			if (k == operand_num) {
				printf("about to decode\n");
				tmp_buf = my_itoa(atoi(cmdLine[k]), tmp_buf, bitNum - 6 - 5 - 5, 2);
				strcat(buf, tmp_buf);
				continue;
			}
			for (i = 0; i < regNum; i++)//regNum: the real registers number 		
			{
				//printf("REG i = %d\n", i);
				if (strcmp(cmdLine[k], reg[i][1]) == 0)	{
					strcat(buf, reg[i][0]);
					i = -1;				
					break;
				}						
			}
			if (i != -1) {
				printf("line %d: %s: register not found!\n", lineNum, cmdLine[k]);
				return -1;
			}
		}
		break;
	
	case 3: //A-type instructions:	JUMP
		for (i = 0; i < labelNum; i++) {
			printf("label name = %s\n", cmdLine[1]);
			if (strcmp(cmdLine[1], label[i][0]) == 0) {
				strcat(buf, label[i][1]);
				i = -1;				
				break;
			}				
		}
		if (i != -1) {
			printf("line %d: %s: LABEL not found!\n", lineNum, cmdLine[1]);
			return -1;
		}
		break;
	}
	tmpLen = strlen(buf);
	for (i = bitNum - 1; i >= tmpLen; i--) {
		strcat(buf, "0");//fill in the tail in order to make 32 bit length
	}
	buf[bitNum] = '\n';
	
	//fwrite(get_code_from_string(buf), 1, bitNum+1, fd);//buf length = 32. last element = '\n'
	x  =  get_code_from_string(buf);
	fprintf(fd, "%c%c%c%c", x&255, (x>>8)&255, (x>>16)&255, (x>>24)&255);
	fwrite(buf, 1, bitNum+1, stdout);
	return 0;			
}
