#include "asl.h"

int main(int argc, char** argv[])
{
	FILE *fd_src, *fd_dst;
	int i, r, lineNum;
	char input_buf[1024];
  	char *arg[10];
  	char*** op = (char***)malloc(maxOpNum * sizeof(char**));
	char*** reg = (char***)malloc(maxRegNum * sizeof(char**));
	char*** label = (char***)malloc(maxLabelNum * sizeof(char**));
	source = "input.txt";
	dest = "output.txt";
	opcode_file = "opcode.txt";
	register_file = "register.txt";
	labelNum = 0;
	fd_src = fopen(source, "r");
	if (fd_src < 0) 
	{
		printf("%s: File not found!\n", source);
		return 1;
	}
	
	fd_dst = fopen(dest, "w+");
	if (fd_dst < 0) 
	{
		printf("%s: File not created!\n", dest);
		fclose(fd_src);
		return 1;
	}
	
	opNum = load_table(opcode_file, op);
	regNum = load_table(register_file, reg);
	lineNum = 0;
	while (fgets(input_buf, 128, fd_src) > 0)
	{
		r = parse(input_buf, arg);
		if (r == 0) continue;
		lineNum++;
		if (getLabels(lineNum, arg, op, label) != 0) goto end;
	}
	printf("number of labels = %d\n", labelNum);
	fclose(fd_src);
	fd_src = fopen(source, "r");
	lineNum = 0;
	while (fgets(input_buf, 128, fd_src) > 0)
	{
		r = parse(input_buf, arg);
		printf("Number of tokens: %d\n", r);
	  	if (r == 0) continue;
		lineNum++;
	  	for (i = 0; i < r; i++)
	  	{
	    	printf("%s\n", arg[i]);
	  	}
	  	if (assemble(lineNum, arg, r, op, reg, label, fd_dst) != 0) goto end;
	}
end:
	free(op);
	free(reg);
  	fclose(fd_src);
  	fclose(fd_dst);  	
  	return 0;
}
